\ Sokoban the one-liner

\ Forth
: floop begin cr c" > emit 129 78 Expect span @ 128 c! cr 128 load again ;
: fdrp dropall rdropall floop ;
: forth ." GP-FORTH console" cr ." [`] - back to game " fdrp ;
: errmsg cr tib tib# @ type cr >in @ spaces c" ? emit ;
: oops errmsg 0 state ! fdrp ;
' oops errorproc !

use set_vm.frl
: bye 2 setvm bye ;
: cls 1 setvm ;

\ Control words
\ : (re) latest name> here - 1+ , ;
\ : re compile branch (re) ; immediate
\ : ?re compile ?branch (re) ; immediate ( bool -- , at runtime )
: ?; if r> drop then ; ( bool -- ) 
\ : ?? ifnot r> 2+ >r then ; ( bool -- )
: rep r@ swap 1 do dup >r @ execute r> loop drop ; ( n -- )

\ Service words
: z! CodeSegment swap 0 mfill ;            ( adr num -- )
: zallot here swap dup allot z! ;          ( num -- )
: [] swap 2* + ;                           ( index array -- addr )

\ Address
variable a
: a! a ! ; 
: a@ a @ ; 
: a+ a 2+! ;
: !a a@ ! ; 
: @a a@ @ ;
: @a+ @a a+ ; 
: !a+ !a a+ ;

6 constant 6
variable m ( man's position )

create fld 402 zallot 
create lvls 402 3 / 2+ 50 * zallot 

\ Field counter
variable f
: 0f! fld f ! ;
: @f+ f @ c@ f 1+! ; 
: !f+ f @ c! f 1+! ;
: fld@ fld + c@ ; ( n -- )
: f- f @ fld - 1- ; ( -- f )

\ Screen
: sc! ( ca x y -- ) 40 * + 2* $ B800 A! ;
( change 40 to 80 if u dunno wanna chg videomode )

\ Colored chars
create spr 18 allot
spr f !
: cword bl word 1+ c@ ; ( -- c )
: spr! 9 0 do cword !f+ cword 48 - !f+ loop ;

spr! . 2 . 2 _ 2 o 2 O 2 # 4 @ 7 @ 7 @ 7 
forget cword 32 spr c!

\ Show 

: ?man f- m @ = 6 * - ; ( n -- n | n+6 )
: d>xy  0 20 ds/mod swap drop ; ( n -- y x )
: spr. spr [] @ f- d>xy 10 + swap sc! ; ( n -- )
: cell. @f+ ?man spr. ; ( -- )
: line. 20 rep cell. ; ( -- )
: show 0f! 20 rep line. ; ( -- )

: n>lv [ 402 3 / 2+ ] literal * lvls + ; ( n -- a )
: 0af! n>lv a! 0f! ; ( n -- )

\ Field to packed level
: 6*+ 6 * @f+ + ; ( n -- n*6+f@ )
: 6pk 0 6 rep 6*+ !a+ ; ( -- )
: f>l 0af! 67 rep 6pk m @ !a+ ; ( n -- )

\ Packed level to field
: 6/ 6 ds/mod -rot ; ( d -- n=d_mod_6 d/6 )
: 6un @a+ 0 6 rep 6/ 2drop 6 rep !f+ ; ( -- )
: l>f 0af! 67 rep 6un @a+ m ! ; ( n -- )

\ Level select
variable lvl
: lvld lvl @ l>f ;
: (lv+ lvl @ + abs 49 mod lvl ! ; ( n -- )
: lv+ 1 (lv+ lvld ;
: lv- -1 (lv+ lvld ;

include levels.frt
 0 lvl ! lvld

( 0 constant outer 1 constant empty ) 2 constant place 3 constant bomb 
( 4 constant sitted ) 5 constant wall

\ Player's control
variable d \ delta - change op man's pos
: move create , does> @ d ! ; 
20 move dn -20 move up -1 move lf 1 move rt

\ Key bindings
create bk 1024 allot
: bkey key dup 0 = if drop key 256 + then ; ( -- k )
: unbind bk CodeSegment 1024 0 mfill ; unbind
: bind ' swap  bk [] ! ; ( k -- )
: kbind ' bkey bk [] ! ;
: kexec bkey bk [] @ ?dup if execute then ;

43 bind lv+
45 bind lv-
32 bind lvld
96 bind forth
328 bind up
336 bind dn
331 bind lf
333 bind rt
27 bind bye

: d+ d @ + ; ( n -- n+d )
: md+ m @ d+ ; ( -- n )
: d+@ md+ fld@ ; ( -- fld@ )
: manmv md+ m ! ; ( -- )
: c+ swap fld + dup c@ rot + swap c! ; ( fld_index d -- )
: bombmv? md+ d+ fld@ place > ?; manmv m @ -2 c+ md+ 2 c+ ;
: rulez d+@ wall = ?; d+@ bomb < if manmv exit then bombmv? ;
: soko begin show 0 d ! kexec rulez again ;
: ` dropall rdropall cls soko ;
: rc interpret " include soko.rc " load ` ;
restart rc

save soko.com
`
